
mv /boot/vmlinux.kpart{,.orig}

options=(
  --oldblob /boot/vmlinux.kpart.orig
  --repack /boot/vmlinux.kpart
  --version 1
  --arch arm
  --keyblock /boot/kernel.keyblock
  --signprivate /boot/kernel_data_key.vbprivk
  --config /boot/cmdline
  --bootloader /boot/bootloader.bin
)
vbutil_kernel "${options[@]}"

major=$(mountpoint -d / | cut -f 1 -d ':')
minor=$(mountpoint -d / | cut -f 2 -d ':')
device=$(cat /proc/partitions | awk {'if ($1 == "'${major}'" && $2 == "'${minor}'") print $4 '})
device="/dev/${device/%2/1}"

echo "A new kernel version needs to be flashed onto ${device}."
echo "Do you want to do this now? [y|N]"
read -r shouldwe
if [[ $shouldwe =~ ^([yY][eE][sS]|[yY])$ ]]; then
  dd if=/boot/vmlinux.kpart of=${device}
  sync
else
  echo "You can do this later by running:"
  echo "# dd if=/boot/vmlinux.kpart of=${device}"
fi
